#include <QGuiApplication>
#include <QQmlApplicationEngine>
#include <QQmlContext>

#include "networkinterface.h"

int main(int argc, char *argv[])
{
#if QT_VERSION < QT_VERSION_CHECK(6, 0, 0)
    QCoreApplication::setAttribute(Qt::AA_EnableHighDpiScaling);
#endif
    QGuiApplication app(argc, argv);

    QQmlApplicationEngine engine;
    const QUrl url(QStringLiteral("qrc:/main.qml"));
    QObject::connect(
        &engine,
        &QQmlApplicationEngine::objectCreated,
        &app,
        [url](QObject *obj, const QUrl &objUrl) {
            if (!obj && url == objUrl)
                QCoreApplication::exit(-1);
        },
        Qt::QueuedConnection);

    NetworkInterface ni{3};
    qmlRegisterUncreatableType<NetworkInterface>("trump.hatesScience",1,0,
                                                 "NetworkInterface",
                                                 "Don't build NetworkInterface from QML");
    engine.rootContext()->setContextProperty("netint", &ni);

    QObjectList allInterfaces;
    for ( QNetworkInterface iface : QNetworkInterface::allInterfaces() ) {
        allInterfaces.push_back(new NetworkInterface{iface});
    }


    engine.rootContext()->setContextProperty("superliste", QVariant::fromValue(allInterfaces));

    engine.load(url);

    return app.exec();
}
